From 8ff6f6e7dd6b1699b5c572f261c33c5b54143ffa Mon Sep 17 00:00:00 2001
From: Coly Li <colyli@suse.de>
Date: Thu, 12 Dec 2019 20:37:09 +0800
Subject: [PATCH 12/16] bcache-tools: rename 2 file names
Git-commit: 8ff6f6e7dd6b1699b5c572f261c33c5b54143ffa
Patch-mainline: bcache-tools-1.1
References: bsc#1139948

This patch renames bcache.c into bcache-crc.c, and renames
bcache-main.c into bcache.c.

This change is for the following change to add crc64 routine
from kernel version.

Signed-off-by: Coly Li <colyli@suse.de>
---
 Makefile      |   6 +-
 bcache-crc.c  | 129 ++++++++
 bcache-main.c | 683 ------------------------------------------
 bcache.c      | 800 ++++++++++++++++++++++++++++++++++++++++++--------
 4 files changed, 809 insertions(+), 809 deletions(-)
 create mode 100644 bcache-crc.c
 delete mode 100644 bcache-main.c

diff --git a/Makefile b/Makefile
index 3bef788..882a170 100644
--- a/Makefile
+++ b/Makefile
@@ -24,18 +24,18 @@ bcache-test: LDLIBS += `pkg-config --libs openssl` -lm
 
 make-bcache: LDLIBS += `pkg-config --libs uuid blkid smartcols`
 make-bcache: CFLAGS += `pkg-config --cflags uuid blkid smartcols`
-make-bcache: make.o bcache.o lib.o 
+make-bcache: make.o bcache-crc.o lib.o
 
 probe-bcache: LDLIBS += `pkg-config --libs uuid blkid`
 probe-bcache: CFLAGS += `pkg-config --cflags uuid blkid`
 
 bcache-super-show: LDLIBS += `pkg-config --libs uuid`
 bcache-super-show: CFLAGS += -std=gnu99
-bcache-super-show: bcache.o
+bcache-super-show: bcache-crc.o
 
 bcache-register: bcache-register.o
 
 bcache: CFLAGS += `pkg-config --cflags blkid uuid smartcols`
 bcache: LDLIBS += `pkg-config --libs blkid uuid smartcols`
 bcache: CFLAGS += -std=gnu99
-bcache: bcache-main.o bcache.o lib.o make.o
+bcache: bcache.o bcache-crc.o lib.o make.o
diff --git a/bcache-crc.c b/bcache-crc.c
new file mode 100644
index 0000000..8b4b986
--- /dev/null
+++ b/bcache-crc.c
@@ -0,0 +1,129 @@
+#define _GNU_SOURCE
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <stdint.h>
+#include <unistd.h>
+
+/*
+ * Portions Copyright (c) 1996-2001, PostgreSQL Global Development Group (Any
+ * use permitted, subject to terms of PostgreSQL license; see.)
+
+ * If we have a 64-bit integer type, then a 64-bit CRC looks just like the
+ * usual sort of implementation. (See Ross Williams' excellent introduction
+ * A PAINLESS GUIDE TO CRC ERROR DETECTION ALGORITHMS, available from
+ * ftp://ftp.rocksoft.com/papers/crc_v3.txt or several other net sites.)
+ * If we have no working 64-bit type, then fake it with two 32-bit registers.
+ *
+ * The present implementation is a normal (not "reflected", in Williams'
+ * terms) 64-bit CRC, using initial all-ones register contents and a final
+ * bit inversion. The chosen polynomial is borrowed from the DLT1 spec
+ * (ECMA-182, available from http://www.ecma.ch/ecma1/STAND/ECMA-182.HTM):
+ *
+ * x^64 + x^62 + x^57 + x^55 + x^54 + x^53 + x^52 + x^47 + x^46 + x^45 +
+ * x^40 + x^39 + x^38 + x^37 + x^35 + x^33 + x^32 + x^31 + x^29 + x^27 +
+ * x^24 + x^23 + x^22 + x^21 + x^19 + x^17 + x^13 + x^12 + x^10 + x^9 +
+ * x^7 + x^4 + x + 1
+*/
+
+static const uint64_t crc_table[256] = {
+	0x0000000000000000ULL, 0x42F0E1EBA9EA3693ULL, 0x85E1C3D753D46D26ULL,
+	0xC711223CFA3E5BB5ULL, 0x493366450E42ECDFULL, 0x0BC387AEA7A8DA4CULL,
+	0xCCD2A5925D9681F9ULL, 0x8E224479F47CB76AULL, 0x9266CC8A1C85D9BEULL,
+	0xD0962D61B56FEF2DULL, 0x17870F5D4F51B498ULL, 0x5577EEB6E6BB820BULL,
+	0xDB55AACF12C73561ULL, 0x99A54B24BB2D03F2ULL, 0x5EB4691841135847ULL,
+	0x1C4488F3E8F96ED4ULL, 0x663D78FF90E185EFULL, 0x24CD9914390BB37CULL,
+	0xE3DCBB28C335E8C9ULL, 0xA12C5AC36ADFDE5AULL, 0x2F0E1EBA9EA36930ULL,
+	0x6DFEFF5137495FA3ULL, 0xAAEFDD6DCD770416ULL, 0xE81F3C86649D3285ULL,
+	0xF45BB4758C645C51ULL, 0xB6AB559E258E6AC2ULL, 0x71BA77A2DFB03177ULL,
+	0x334A9649765A07E4ULL, 0xBD68D2308226B08EULL, 0xFF9833DB2BCC861DULL,
+	0x388911E7D1F2DDA8ULL, 0x7A79F00C7818EB3BULL, 0xCC7AF1FF21C30BDEULL,
+	0x8E8A101488293D4DULL, 0x499B3228721766F8ULL, 0x0B6BD3C3DBFD506BULL,
+	0x854997BA2F81E701ULL, 0xC7B97651866BD192ULL, 0x00A8546D7C558A27ULL,
+	0x4258B586D5BFBCB4ULL, 0x5E1C3D753D46D260ULL, 0x1CECDC9E94ACE4F3ULL,
+	0xDBFDFEA26E92BF46ULL, 0x990D1F49C77889D5ULL, 0x172F5B3033043EBFULL,
+	0x55DFBADB9AEE082CULL, 0x92CE98E760D05399ULL, 0xD03E790CC93A650AULL,
+	0xAA478900B1228E31ULL, 0xE8B768EB18C8B8A2ULL, 0x2FA64AD7E2F6E317ULL,
+	0x6D56AB3C4B1CD584ULL, 0xE374EF45BF6062EEULL, 0xA1840EAE168A547DULL,
+	0x66952C92ECB40FC8ULL, 0x2465CD79455E395BULL, 0x3821458AADA7578FULL,
+	0x7AD1A461044D611CULL, 0xBDC0865DFE733AA9ULL, 0xFF3067B657990C3AULL,
+	0x711223CFA3E5BB50ULL, 0x33E2C2240A0F8DC3ULL, 0xF4F3E018F031D676ULL,
+	0xB60301F359DBE0E5ULL, 0xDA050215EA6C212FULL, 0x98F5E3FE438617BCULL,
+	0x5FE4C1C2B9B84C09ULL, 0x1D14202910527A9AULL, 0x93366450E42ECDF0ULL,
+	0xD1C685BB4DC4FB63ULL, 0x16D7A787B7FAA0D6ULL, 0x5427466C1E109645ULL,
+	0x4863CE9FF6E9F891ULL, 0x0A932F745F03CE02ULL, 0xCD820D48A53D95B7ULL,
+	0x8F72ECA30CD7A324ULL, 0x0150A8DAF8AB144EULL, 0x43A04931514122DDULL,
+	0x84B16B0DAB7F7968ULL, 0xC6418AE602954FFBULL, 0xBC387AEA7A8DA4C0ULL,
+	0xFEC89B01D3679253ULL, 0x39D9B93D2959C9E6ULL, 0x7B2958D680B3FF75ULL,
+	0xF50B1CAF74CF481FULL, 0xB7FBFD44DD257E8CULL, 0x70EADF78271B2539ULL,
+	0x321A3E938EF113AAULL, 0x2E5EB66066087D7EULL, 0x6CAE578BCFE24BEDULL,
+	0xABBF75B735DC1058ULL, 0xE94F945C9C3626CBULL, 0x676DD025684A91A1ULL,
+	0x259D31CEC1A0A732ULL, 0xE28C13F23B9EFC87ULL, 0xA07CF2199274CA14ULL,
+	0x167FF3EACBAF2AF1ULL, 0x548F120162451C62ULL, 0x939E303D987B47D7ULL,
+	0xD16ED1D631917144ULL, 0x5F4C95AFC5EDC62EULL, 0x1DBC74446C07F0BDULL,
+	0xDAAD56789639AB08ULL, 0x985DB7933FD39D9BULL, 0x84193F60D72AF34FULL,
+	0xC6E9DE8B7EC0C5DCULL, 0x01F8FCB784FE9E69ULL, 0x43081D5C2D14A8FAULL,
+	0xCD2A5925D9681F90ULL, 0x8FDAB8CE70822903ULL, 0x48CB9AF28ABC72B6ULL,
+	0x0A3B7B1923564425ULL, 0x70428B155B4EAF1EULL, 0x32B26AFEF2A4998DULL,
+	0xF5A348C2089AC238ULL, 0xB753A929A170F4ABULL, 0x3971ED50550C43C1ULL,
+	0x7B810CBBFCE67552ULL, 0xBC902E8706D82EE7ULL, 0xFE60CF6CAF321874ULL,
+	0xE224479F47CB76A0ULL, 0xA0D4A674EE214033ULL, 0x67C58448141F1B86ULL,
+	0x253565A3BDF52D15ULL, 0xAB1721DA49899A7FULL, 0xE9E7C031E063ACECULL,
+	0x2EF6E20D1A5DF759ULL, 0x6C0603E6B3B7C1CAULL, 0xF6FAE5C07D3274CDULL,
+	0xB40A042BD4D8425EULL, 0x731B26172EE619EBULL, 0x31EBC7FC870C2F78ULL,
+	0xBFC9838573709812ULL, 0xFD39626EDA9AAE81ULL, 0x3A28405220A4F534ULL,
+	0x78D8A1B9894EC3A7ULL, 0x649C294A61B7AD73ULL, 0x266CC8A1C85D9BE0ULL,
+	0xE17DEA9D3263C055ULL, 0xA38D0B769B89F6C6ULL, 0x2DAF4F0F6FF541ACULL,
+	0x6F5FAEE4C61F773FULL, 0xA84E8CD83C212C8AULL, 0xEABE6D3395CB1A19ULL,
+	0x90C79D3FEDD3F122ULL, 0xD2377CD44439C7B1ULL, 0x15265EE8BE079C04ULL,
+	0x57D6BF0317EDAA97ULL, 0xD9F4FB7AE3911DFDULL, 0x9B041A914A7B2B6EULL,
+	0x5C1538ADB04570DBULL, 0x1EE5D94619AF4648ULL, 0x02A151B5F156289CULL,
+	0x4051B05E58BC1E0FULL, 0x87409262A28245BAULL, 0xC5B073890B687329ULL,
+	0x4B9237F0FF14C443ULL, 0x0962D61B56FEF2D0ULL, 0xCE73F427ACC0A965ULL,
+	0x8C8315CC052A9FF6ULL, 0x3A80143F5CF17F13ULL, 0x7870F5D4F51B4980ULL,
+	0xBF61D7E80F251235ULL, 0xFD913603A6CF24A6ULL, 0x73B3727A52B393CCULL,
+	0x31439391FB59A55FULL, 0xF652B1AD0167FEEAULL, 0xB4A25046A88DC879ULL,
+	0xA8E6D8B54074A6ADULL, 0xEA16395EE99E903EULL, 0x2D071B6213A0CB8BULL,
+	0x6FF7FA89BA4AFD18ULL, 0xE1D5BEF04E364A72ULL, 0xA3255F1BE7DC7CE1ULL,
+	0x64347D271DE22754ULL, 0x26C49CCCB40811C7ULL, 0x5CBD6CC0CC10FAFCULL,
+	0x1E4D8D2B65FACC6FULL, 0xD95CAF179FC497DAULL, 0x9BAC4EFC362EA149ULL,
+	0x158E0A85C2521623ULL, 0x577EEB6E6BB820B0ULL, 0x906FC95291867B05ULL,
+	0xD29F28B9386C4D96ULL, 0xCEDBA04AD0952342ULL, 0x8C2B41A1797F15D1ULL,
+	0x4B3A639D83414E64ULL, 0x09CA82762AAB78F7ULL, 0x87E8C60FDED7CF9DULL,
+	0xC51827E4773DF90EULL, 0x020905D88D03A2BBULL, 0x40F9E43324E99428ULL,
+	0x2CFFE7D5975E55E2ULL, 0x6E0F063E3EB46371ULL, 0xA91E2402C48A38C4ULL,
+	0xEBEEC5E96D600E57ULL, 0x65CC8190991CB93DULL, 0x273C607B30F68FAEULL,
+	0xE02D4247CAC8D41BULL, 0xA2DDA3AC6322E288ULL, 0xBE992B5F8BDB8C5CULL,
+	0xFC69CAB42231BACFULL, 0x3B78E888D80FE17AULL, 0x7988096371E5D7E9ULL,
+	0xF7AA4D1A85996083ULL, 0xB55AACF12C735610ULL, 0x724B8ECDD64D0DA5ULL,
+	0x30BB6F267FA73B36ULL, 0x4AC29F2A07BFD00DULL, 0x08327EC1AE55E69EULL,
+	0xCF235CFD546BBD2BULL, 0x8DD3BD16FD818BB8ULL, 0x03F1F96F09FD3CD2ULL,
+	0x41011884A0170A41ULL, 0x86103AB85A2951F4ULL, 0xC4E0DB53F3C36767ULL,
+	0xD8A453A01B3A09B3ULL, 0x9A54B24BB2D03F20ULL, 0x5D45907748EE6495ULL,
+	0x1FB5719CE1045206ULL, 0x919735E51578E56CULL, 0xD367D40EBC92D3FFULL,
+	0x1476F63246AC884AULL, 0x568617D9EF46BED9ULL, 0xE085162AB69D5E3CULL,
+	0xA275F7C11F7768AFULL, 0x6564D5FDE549331AULL, 0x279434164CA30589ULL,
+	0xA9B6706FB8DFB2E3ULL, 0xEB46918411358470ULL, 0x2C57B3B8EB0BDFC5ULL,
+	0x6EA7525342E1E956ULL, 0x72E3DAA0AA188782ULL, 0x30133B4B03F2B111ULL,
+	0xF7021977F9CCEAA4ULL, 0xB5F2F89C5026DC37ULL, 0x3BD0BCE5A45A6B5DULL,
+	0x79205D0E0DB05DCEULL, 0xBE317F32F78E067BULL, 0xFCC19ED95E6430E8ULL,
+	0x86B86ED5267CDBD3ULL, 0xC4488F3E8F96ED40ULL, 0x0359AD0275A8B6F5ULL,
+	0x41A94CE9DC428066ULL, 0xCF8B0890283E370CULL, 0x8D7BE97B81D4019FULL,
+	0x4A6ACB477BEA5A2AULL, 0x089A2AACD2006CB9ULL, 0x14DEA25F3AF9026DULL,
+	0x562E43B4931334FEULL, 0x913F6188692D6F4BULL, 0xD3CF8063C0C759D8ULL,
+	0x5DEDC41A34BBEEB2ULL, 0x1F1D25F19D51D821ULL, 0xD80C07CD676F8394ULL,
+	0x9AFCE626CE85B507ULL
+};
+
+uint64_t crc64(const void *_data, size_t len)
+{
+	uint64_t crc = 0xFFFFFFFFFFFFFFFFULL;
+	const unsigned char *data = _data;
+
+	while (len--) {
+		int i = ((int) (crc >> 56) ^ *data++) & 0xFF;
+		crc = crc_table[i] ^ (crc << 8);
+	}
+
+	return crc ^ 0xFFFFFFFFFFFFFFFFULL;
+}
diff --git a/bcache-main.c b/bcache-main.c
deleted file mode 100644
index c0b09b8..0000000
--- a/bcache-main.c
+++ /dev/null
@@ -1,683 +0,0 @@
-// SPDX-License-Identifier: GPL-2.0
-// Author: Shaoxiong Li <dahefanteng@gmail.com>
-
-#include <stdio.h>
-#include <inttypes.h>
-#include <string.h>
-#include <stdint.h>
-#include <stdlib.h>
-#include <stdbool.h>
-#include <unistd.h>
-#include <getopt.h>
-#include <regex.h>
-#include <libsmartcols/libsmartcols.h>
-#include "bcache.h"
-#include "lib.h"
-#include "make.h"
-#include <locale.h>
-#include "list.h"
-#include <limits.h>
-
-
-//utils function
-static bool accepted_char(char c)
-{
-	if ('0' <= c && c <= '9')
-		return true;
-	if ('A' <= c && c <= 'Z')
-		return true;
-	if ('a' <= c && c <= 'z')
-		return true;
-	if (strchr(".-_", c))
-		return true;
-	return false;
-}
-
-static void print_encode(char *in)
-{
-	char *pos;
-
-	for (pos = in; *pos; pos++)
-		if (accepted_char(*pos))
-			putchar(*pos);
-		else
-			printf("%%%x", *pos);
-}
-
-bool bad_uuid(char *uuid)
-{
-	const char *pattern =
-	    "^[a-z0-9]{8}-[a-z0-9]{4}-[a-z0-9]{4}-[a-z0-9]{4}-[a-z0-9]{12}$";
-	regex_t reg;
-	int status;
-	regmatch_t regmatche;
-
-	if (regcomp(&reg, pattern, REG_EXTENDED) != 0)
-		fprintf(stderr, "Error happen when check uuid format:%m\n");
-	status = regexec(&reg, uuid, 1, &regmatche, 0);
-	regfree(&reg);
-	if (status == REG_NOMATCH)
-		return true;
-	else
-		return false;
-}
-
-bool bad_dev(char **devname)
-{
-
-	char *ptr = realpath(*devname, NULL);
-
-	if (ptr == NULL) {
-		fprintf(stderr, "Error:Failed to resolve device name\n");
-		return true;
-	}
-	*devname = ptr;
-	char *pattern = "^/dev/[a-zA-Z0-9-]*$";
-	regex_t reg;
-	int status;
-	regmatch_t regmatche;
-
-	if (regcomp(&reg, pattern, REG_EXTENDED) != 0) {
-		fprintf(stderr,
-			"Error happen when check device name format:%m\n");
-	}
-	status = regexec(&reg, *devname, 1, &regmatche, 0);
-	regfree(&reg);
-	if (status == REG_NOMATCH)
-		return true;
-	else
-		return false;
-}
-
-
-int main_usage(void)
-{
-	fprintf(stderr,
-		"Usage:bcache [SUBCMD]\n"
-		"	show		show all bcache devices in this host\n"
-		"	tree		show active bcache devices in this host\n"
-		"	make		make regular device to bcache device\n"
-		"	register	register device to kernel\n"
-		"	unregister	unregister device from kernel\n"
-		"	attach		attach backend device(data device) to cache device\n"
-		"	detach		detach backend device(data device) from cache device\n"
-		"	set-cachemode	set cachemode for backend device\n"
-		"	set-label	set label for backend device\n");
-	return EXIT_FAILURE;
-}
-
-int show_usage(void)
-{
-	fprintf(stderr,
-		"Usage:	show [option]\n"
-		"	show overall information about all devices\n"
-		"	-d	--device {devname}	show the detail infomation about this device\n"
-		"	-m	--more			show overall information about all devices with detail info\n"
-		"	-h	--help			show help information\n");
-	return EXIT_FAILURE;
-}
-
-int tree_usage(void)
-{
-	fprintf(stderr,
-		"Usage: tree	show active bcache devices in this host\n");
-	return EXIT_FAILURE;
-}
-
-int register_usage(void)
-{
-	fprintf(stderr,
-		"Usage:register devicename		register device as bcache device to kernel\n");
-	return EXIT_FAILURE;
-}
-
-int unregister_usage(void)
-{
-	fprintf(stderr,
-		"Usage:unregister devicename		unregister device from kernel\n");
-	return EXIT_FAILURE;
-}
-
-int attach_usage(void)
-{
-	fprintf(stderr, "Usage:attach cset_uuid|cachedevice datadevice\n");
-	return EXIT_FAILURE;
-}
-
-int detach_usage(void)
-{
-	fprintf(stderr, "Usage:detach devicename\n");
-	return EXIT_FAILURE;
-}
-
-int setcachemode_usage(void)
-{
-	fprintf(stderr, "Usage:set-cachemode devicename modetype\n");
-	return EXIT_FAILURE;
-}
-
-int setlabel_usage(void)
-{
-	fprintf(stderr,
-		"Usage:set-label devicename label\n(only for backend device)\n");
-	return EXIT_FAILURE;
-}
-
-void free_dev(struct list_head *head)
-{
-	struct dev *dev;
-
-	list_for_each_entry(dev, head, dev_list) {
-		free(dev);
-	}
-}
-
-int show_bdevs_detail(void)
-{
-	struct list_head head;
-	struct dev *devs;
-
-	INIT_LIST_HEAD(&head);
-	int ret;
-
-	ret = list_bdevs(&head);
-	if (ret != 0) {
-		fprintf(stderr, "Failed to list devices\n");
-		return ret;
-	}
-	printf("Name\t\tUuid\t\t\t\t\tCset_Uuid\t\t\t\tType\t\tState");
-	printf("\t\t\tBname\t\tAttachToDev\tAttachToCset\n");
-	list_for_each_entry(devs, &head, dev_list) {
-		printf("%s\t%s\t%s\t%lu", devs->name, devs->uuid,
-		       devs->cset, devs->version);
-		switch (devs->version) {
-			// These are handled the same by the kernel
-		case BCACHE_SB_VERSION_CDEV:
-		case BCACHE_SB_VERSION_CDEV_WITH_UUID:
-			printf(" (cache)");
-			break;
-			// The second adds data offset supporet
-		case BCACHE_SB_VERSION_BDEV:
-		case BCACHE_SB_VERSION_BDEV_WITH_OFFSET:
-			printf(" (data)");
-			break;
-		default:
-			printf(" (unknown)");
-			break;
-		}
-		printf("\t%-16s", devs->state);
-		printf("\t%-16s", devs->bname);
-		char attachdev[30];
-
-		if (strlen(devs->attachuuid) == 36) {
-			cset_to_devname(&head, devs->cset, attachdev);
-		} else if (devs->version == BCACHE_SB_VERSION_CDEV
-			   || devs->version ==
-			   BCACHE_SB_VERSION_CDEV_WITH_UUID) {
-			strcpy(attachdev, BCACHE_NO_SUPPORT);
-		} else {
-			strcpy(attachdev, BCACHE_ATTACH_ALONE);
-		}
-		printf("%-16s", attachdev);
-		printf("%s", devs->attachuuid);
-		putchar('\n');
-	}
-	free_dev(&head);
-	return 0;
-}
-
-
-int show_bdevs(void)
-{
-	struct list_head head;
-	struct dev *devs;
-
-	INIT_LIST_HEAD(&head);
-	int ret;
-
-	ret = list_bdevs(&head);
-	if (ret != 0) {
-		fprintf(stderr, "Failed to list devices\n");
-		return ret;
-	}
-
-	printf("Name\t\tType\t\tState\t\t\tBname\t\tAttachToDev\n");
-	list_for_each_entry(devs, &head, dev_list) {
-		printf("%s\t%lu", devs->name, devs->version);
-		switch (devs->version) {
-			// These are handled the same by the kernel
-		case BCACHE_SB_VERSION_CDEV:
-		case BCACHE_SB_VERSION_CDEV_WITH_UUID:
-			printf(" (cache)");
-			break;
-
-			// The second adds data offset supporet
-		case BCACHE_SB_VERSION_BDEV:
-		case BCACHE_SB_VERSION_BDEV_WITH_OFFSET:
-			printf(" (data)");
-			break;
-
-		default:
-			printf(" (unknown)");
-			break;
-		}
-
-		printf("\t%-16s", devs->state);
-		printf("\t%-16s", devs->bname);
-
-		char attachdev[30];
-
-		if (strlen(devs->attachuuid) == 36) {
-			cset_to_devname(&head, devs->cset, attachdev);
-		} else if (devs->version == BCACHE_SB_VERSION_CDEV
-			   || devs->version ==
-			   BCACHE_SB_VERSION_CDEV_WITH_UUID) {
-			strcpy(attachdev, BCACHE_NO_SUPPORT);
-		} else {
-			strcpy(attachdev, BCACHE_ATTACH_ALONE);
-		}
-		printf("%s", attachdev);
-		putchar('\n');
-	}
-	free_dev(&head);
-	return 0;
-}
-
-int detail_single(char *devname)
-{
-	struct bdev bd;
-	struct cdev cd;
-	int type = 1;
-	int ret;
-
-	ret = detail_dev(devname, &bd, &cd, &type);
-	if (ret != 0) {
-		fprintf(stderr, "Failed to detail device\n");
-		return ret;
-	}
-	if (type == BCACHE_SB_VERSION_BDEV) {
-		printf("sb.magic\t\t%s\n", bd.base.magic);
-		printf("sb.first_sector\t\t%" PRIu64 "\n",
-		       bd.base.first_sector);
-		printf("sb.csum\t\t\t%" PRIX64 "\n", bd.base.csum);
-		printf("sb.version\t\t%" PRIu64, bd.base.version);
-		printf(" [backing device]\n");
-		putchar('\n');
-		printf("dev.label\t\t");
-		if (*bd.base.label)
-			print_encode(bd.base.label);
-		else
-			printf("(empty)");
-		putchar('\n');
-		printf("dev.uuid\t\t%s\n", bd.base.uuid);
-		printf("dev.sectors_per_block\t%u\n"
-		       "dev.sectors_per_bucket\t%u\n",
-		       bd.base.sectors_per_block,
-		       bd.base.sectors_per_bucket);
-		printf("dev.data.first_sector\t%u\n"
-		       "dev.data.cache_mode\t%d",
-		       bd.first_sector, bd.cache_mode);
-		switch (bd.cache_mode) {
-		case CACHE_MODE_WRITETHROUGH:
-			printf(" [writethrough]\n");
-			break;
-		case CACHE_MODE_WRITEBACK:
-			printf(" [writeback]\n");
-			break;
-		case CACHE_MODE_WRITEAROUND:
-			printf(" [writearound]\n");
-			break;
-		case CACHE_MODE_NONE:
-			printf(" [no caching]\n");
-			break;
-		default:
-			putchar('\n');
-		}
-		printf("dev.data.cache_state\t%u", bd.cache_state);
-		switch (bd.cache_state) {
-		case BDEV_STATE_NONE:
-			printf(" [detached]\n");
-			break;
-		case BDEV_STATE_CLEAN:
-			printf(" [clean]\n");
-			break;
-		case BDEV_STATE_DIRTY:
-			printf(" [dirty]\n");
-			break;
-		case BDEV_STATE_STALE:
-			printf(" [inconsistent]\n");
-			break;
-		default:
-			putchar('\n');
-		}
-
-		putchar('\n');
-		printf("cset.uuid\t\t%s\n", bd.base.cset);
-	} else if (type == BCACHE_SB_VERSION_CDEV
-		   || type == BCACHE_SB_VERSION_CDEV_WITH_UUID) {
-		printf("sb.magic\t\t%s\n", cd.base.magic);
-		printf("sb.first_sector\t\t%" PRIu64 "\n",
-		       cd.base.first_sector);
-		printf("sb.csum\t\t\t%" PRIX64 "\n", cd.base.csum);
-		printf("sb.version\t\t%" PRIu64, cd.base.version);
-		printf(" [cache device]\n");
-		putchar('\n');
-		printf("dev.label\t\t");
-		if (*cd.base.label)
-			print_encode(cd.base.label);
-		else
-			printf("(empty)");
-		putchar('\n');
-		printf("dev.uuid\t\t%s\n", cd.base.uuid);
-		printf("dev.sectors_per_block\t%u\n"
-		       "dev.sectors_per_bucket\t%u\n",
-		       cd.base.sectors_per_block,
-		       cd.base.sectors_per_bucket);
-		printf("dev.cache.first_sector\t%u\n"
-		       "dev.cache.cache_sectors\t%ju\n"
-		       "dev.cache.total_sectors\t%ju\n"
-		       "dev.cache.ordered\t%s\n"
-		       "dev.cache.discard\t%s\n"
-		       "dev.cache.pos\t\t%u\n"
-		       "dev.cache.replacement\t%d",
-		       cd.first_sector,
-		       cd.cache_sectors,
-		       cd.total_sectors,
-		       cd.ordered ? "yes" : "no",
-		       cd.discard ? "yes" : "no", cd.pos, cd.replacement);
-		switch (cd.replacement) {
-		case CACHE_REPLACEMENT_LRU:
-			printf(" [lru]\n");
-			break;
-		case CACHE_REPLACEMENT_FIFO:
-			printf(" [fifo]\n");
-			break;
-		case CACHE_REPLACEMENT_RANDOM:
-			printf(" [random]\n");
-			break;
-		default:
-			putchar('\n');
-		}
-
-		putchar('\n');
-		printf("cset.uuid\t\t%s\n", cd.base.cset);
-	} else {
-		return 1;
-	}
-	return 0;
-}
-
-int tree(void)
-{
-	struct list_head head;
-	struct dev *devs, *tmp;
-
-	INIT_LIST_HEAD(&head);
-	int ret;
-
-	ret = list_bdevs(&head);
-	if (ret != 0) {
-		fprintf(stderr, "Failed to list devices\n");
-		return ret;
-	}
-	struct libscols_table *tb;
-	struct libscols_line *dad, *son;
-	enum { COL_CSET, COL_BNAME };
-	setlocale(LC_ALL, "");
-	tb = scols_new_table();
-	scols_table_new_column(tb, ".", 0.1, SCOLS_FL_TREE);
-	scols_table_new_column(tb, "", 2, SCOLS_FL_TRUNC);
-	list_for_each_entry(devs, &head, dev_list) {
-		if ((devs->version == BCACHE_SB_VERSION_CDEV
-		     || devs->version == BCACHE_SB_VERSION_CDEV_WITH_UUID)
-		    && strcmp(devs->state, BCACHE_BASIC_STATE_ACTIVE) == 0) {
-			dad = scols_table_new_line(tb, NULL);
-			scols_line_set_data(dad, COL_CSET, devs->name);
-			list_for_each_entry(tmp, &head, dev_list) {
-				if (strcmp(devs->cset, tmp->attachuuid) ==
-				    0) {
-					son =
-					    scols_table_new_line(tb, dad);
-					scols_line_set_data(son, COL_CSET,
-							    tmp->name);
-					scols_line_set_data(son, COL_BNAME,
-							    tmp->bname);
-				}
-			}
-		}
-	}
-	scols_print_table(tb);
-	scols_unref_table(tb);
-	free_dev(&head);
-	return 0;
-}
-
-int attach_both(char *cdev, char *backdev)
-{
-	struct bdev bd;
-	struct cdev cd;
-	int type = 1;
-	int ret;
-	char buf[100];
-
-	ret = detail_dev(backdev, &bd, &cd, &type);
-	if (ret != 0)
-		return ret;
-	if (type != BCACHE_SB_VERSION_BDEV
-	    && type != BCACHE_SB_VERSION_BDEV_WITH_OFFSET) {
-		fprintf(stderr, "%s is not an backend device\n", backdev);
-		return 1;
-	}
-	if (strcmp(bd.base.attachuuid, BCACHE_BNAME_NOT_EXIST) != 0) {
-		fprintf(stderr,
-			"This device have attached to another cset\n");
-		return 1;
-	}
-
-	if (strlen(cdev) != 36) {
-		ret = detail_dev(cdev, &bd, &cd, &type);
-		if (type != BCACHE_SB_VERSION_CDEV
-		    && type != BCACHE_SB_VERSION_CDEV_WITH_UUID) {
-			fprintf(stderr, "%s is not an cache device\n", cdev);
-			return 1;
-		}
-		strcpy(buf, cd.base.cset);
-	} else {
-		strcpy(buf, cdev);
-	}
-	return attach_backdev(buf, backdev);
-}
-
-bool has_permission(void)
-{
-	uid_t euid = geteuid();
-
-	if (euid != 0)
-		return false;
-	return true;
-}
-
-int main(int argc, char **argv)
-{
-	char *subcmd;
-
-	if (!has_permission()) {
-		fprintf(stderr,
-		"Only root or users who has root priviledges can run this command\n");
-		return 1;
-	}
-	if (argc < 2) {
-		main_usage();
-		return 1;
-	}
-	subcmd = argv[1];
-	argc--;
-	argv += 1;
-	char *devname = NULL;
-	if (strcmp(subcmd, "make") == 0)
-		return make_bcache(argc, argv);
-	else if (strcmp(subcmd, "show") == 0) {
-		int o = 0;
-		int more = 0;
-		int device = 0;
-		int help = 0;
-
-		static struct option long_options[] = {
-			{"more", no_argument, 0, 'm'},
-			{"help", no_argument, 0, 'h'},
-			{"device", required_argument, 0, 'd'},
-			{0, 0, 0, 0}
-		};
-		int option_index = 0;
-
-		while ((o =
-			getopt_long(argc, argv, "hmd:", long_options,
-				    &option_index)) != EOF) {
-			switch (o) {
-			case 'd':
-				devname = optarg;
-				device = 1;
-				break;
-			case 'm':
-				more = 1;
-				break;
-			case 'h':
-				help = 1;
-				break;
-			case '?':
-				return 1;
-			}
-		}
-		argc -= optind;
-		if (help || argc != 0) {
-			return show_usage();
-		} else if (more) {
-			return show_bdevs_detail();
-		} else if (device) {
-			if (bad_dev(&devname)) {
-				fprintf(stderr,
-					"Error:Wrong device name found\n");
-				return 1;
-			}
-			return detail_single(devname);
-		} else {
-			return show_bdevs();
-		}
-	} else if (strcmp(subcmd, "tree") == 0) {
-		if (argc != 1)
-			return tree_usage();
-		return tree();
-	} else if (strcmp(subcmd, "register") == 0) {
-		if (argc != 2 || strcmp(argv[1], "-h") == 0)
-			return register_usage();
-		devname = argv[1];
-		if (bad_dev(&devname)) {
-			fprintf(stderr, "Error:Wrong device name found\n");
-			return 1;
-		}
-		return register_dev(devname);
-	} else if (strcmp(subcmd, "unregister") == 0) {
-		if (argc != 2 || strcmp(argv[1], "-h") == 0)
-			return unregister_usage();
-		devname = argv[1];
-		if (bad_dev(&devname)) {
-			fprintf(stderr, "Error:Wrong device name found\n");
-			return 1;
-		}
-		struct bdev bd;
-		struct cdev cd;
-		int type = 1;
-		int ret;
-
-		ret = detail_dev(devname, &bd, &cd, &type);
-		if (ret != 0)
-			return ret;
-		if (type == BCACHE_SB_VERSION_BDEV) {
-			return stop_backdev(devname);
-		} else if (type == BCACHE_SB_VERSION_CDEV
-			   || type == BCACHE_SB_VERSION_CDEV_WITH_UUID) {
-			return unregister_cset(cd.base.cset);
-		}
-		return 1;
-	} else if (strcmp(subcmd, "attach") == 0) {
-		if (argc != 3 || strcmp(argv[1], "-h") == 0)
-			return attach_usage();
-		devname = argv[2];
-		char *attachto = argv[1];
-
-		if ((bad_uuid(attachto) && bad_dev(&attachto))
-			|| bad_dev(&devname)) {
-			fprintf(stderr,
-			"Error:Wrong device name or cache_set uuid found\n");
-			return 1;
-		}
-		return attach_both(attachto, devname);
-	} else if (strcmp(subcmd, "detach") == 0) {
-		if (argc != 2 || strcmp(argv[1], "-h") == 0)
-			return detach_usage();
-		devname = argv[1];
-		if (bad_dev(&devname)) {
-			fprintf(stderr, "Error:Wrong device name found\n");
-			return 1;
-		}
-		return detach_backdev(devname);
-	} else if (strcmp(subcmd, "set-cachemode") == 0) {
-		if (argc != 3)
-			return setcachemode_usage();
-		devname = argv[1];
-		if (bad_dev(&devname)) {
-			fprintf(stderr, "Error:Wrong device name found\n");
-			return 1;
-		}
-		struct bdev bd;
-		struct cdev cd;
-		int type = 1;
-		int ret;
-
-		ret = detail_dev(devname, &bd, &cd, &type);
-		if (ret != 0) {
-			fprintf(stderr,
-			"This device doesn't exist or failed to receive info from this device\n");
-			return ret;
-		}
-		if (type != BCACHE_SB_VERSION_BDEV
-		    && type != BCACHE_SB_VERSION_BDEV_WITH_OFFSET) {
-			fprintf(stderr,
-				"Only backend device is suppported\n");
-			return 1;
-		}
-		return set_backdev_cachemode(devname, argv[2]);
-	} else if (strcmp(subcmd, "set-label") == 0) {
-		if (argc != 3)
-			return setlabel_usage();
-		devname = argv[1];
-		if (bad_dev(&devname)) {
-			fprintf(stderr, "Error:Wrong device name found\n");
-			return 1;
-		}
-		struct bdev bd;
-		struct cdev cd;
-		int type = 5;
-		int ret;
-
-		ret = detail_dev(devname, &bd, &cd, &type);
-		if (ret != 0) {
-			fprintf(stderr,
-		"This device doesn't exist or failed to receive info from this device\n");
-			return ret;
-		}
-		if (type != BCACHE_SB_VERSION_BDEV
-		    && type != BCACHE_SB_VERSION_BDEV_WITH_OFFSET) {
-			fprintf(stderr,
-				"Only backend device is suppported\n");
-			return 1;
-		}
-		if (strlen(argv[2]) >= SB_LABEL_SIZE) {
-			fprintf(stderr, "Label is too long\n");
-			return 1;
-		}
-		return set_label(devname, argv[2]);
-	}
-	main_usage();
-	return 0;
-}
diff --git a/bcache.c b/bcache.c
index 8b4b986..c0b09b8 100644
--- a/bcache.c
+++ b/bcache.c
@@ -1,129 +1,683 @@
-#define _GNU_SOURCE
+// SPDX-License-Identifier: GPL-2.0
+// Author: Shaoxiong Li <dahefanteng@gmail.com>
 
 #include <stdio.h>
-#include <stdlib.h>
+#include <inttypes.h>
+#include <string.h>
 #include <stdint.h>
+#include <stdlib.h>
+#include <stdbool.h>
 #include <unistd.h>
+#include <getopt.h>
+#include <regex.h>
+#include <libsmartcols/libsmartcols.h>
+#include "bcache.h"
+#include "lib.h"
+#include "make.h"
+#include <locale.h>
+#include "list.h"
+#include <limits.h>
+
+
+//utils function
+static bool accepted_char(char c)
+{
+	if ('0' <= c && c <= '9')
+		return true;
+	if ('A' <= c && c <= 'Z')
+		return true;
+	if ('a' <= c && c <= 'z')
+		return true;
+	if (strchr(".-_", c))
+		return true;
+	return false;
+}
+
+static void print_encode(char *in)
+{
+	char *pos;
+
+	for (pos = in; *pos; pos++)
+		if (accepted_char(*pos))
+			putchar(*pos);
+		else
+			printf("%%%x", *pos);
+}
+
+bool bad_uuid(char *uuid)
+{
+	const char *pattern =
+	    "^[a-z0-9]{8}-[a-z0-9]{4}-[a-z0-9]{4}-[a-z0-9]{4}-[a-z0-9]{12}$";
+	regex_t reg;
+	int status;
+	regmatch_t regmatche;
+
+	if (regcomp(&reg, pattern, REG_EXTENDED) != 0)
+		fprintf(stderr, "Error happen when check uuid format:%m\n");
+	status = regexec(&reg, uuid, 1, &regmatche, 0);
+	regfree(&reg);
+	if (status == REG_NOMATCH)
+		return true;
+	else
+		return false;
+}
+
+bool bad_dev(char **devname)
+{
+
+	char *ptr = realpath(*devname, NULL);
+
+	if (ptr == NULL) {
+		fprintf(stderr, "Error:Failed to resolve device name\n");
+		return true;
+	}
+	*devname = ptr;
+	char *pattern = "^/dev/[a-zA-Z0-9-]*$";
+	regex_t reg;
+	int status;
+	regmatch_t regmatche;
+
+	if (regcomp(&reg, pattern, REG_EXTENDED) != 0) {
+		fprintf(stderr,
+			"Error happen when check device name format:%m\n");
+	}
+	status = regexec(&reg, *devname, 1, &regmatche, 0);
+	regfree(&reg);
+	if (status == REG_NOMATCH)
+		return true;
+	else
+		return false;
+}
+
+
+int main_usage(void)
+{
+	fprintf(stderr,
+		"Usage:bcache [SUBCMD]\n"
+		"	show		show all bcache devices in this host\n"
+		"	tree		show active bcache devices in this host\n"
+		"	make		make regular device to bcache device\n"
+		"	register	register device to kernel\n"
+		"	unregister	unregister device from kernel\n"
+		"	attach		attach backend device(data device) to cache device\n"
+		"	detach		detach backend device(data device) from cache device\n"
+		"	set-cachemode	set cachemode for backend device\n"
+		"	set-label	set label for backend device\n");
+	return EXIT_FAILURE;
+}
+
+int show_usage(void)
+{
+	fprintf(stderr,
+		"Usage:	show [option]\n"
+		"	show overall information about all devices\n"
+		"	-d	--device {devname}	show the detail infomation about this device\n"
+		"	-m	--more			show overall information about all devices with detail info\n"
+		"	-h	--help			show help information\n");
+	return EXIT_FAILURE;
+}
+
+int tree_usage(void)
+{
+	fprintf(stderr,
+		"Usage: tree	show active bcache devices in this host\n");
+	return EXIT_FAILURE;
+}
+
+int register_usage(void)
+{
+	fprintf(stderr,
+		"Usage:register devicename		register device as bcache device to kernel\n");
+	return EXIT_FAILURE;
+}
+
+int unregister_usage(void)
+{
+	fprintf(stderr,
+		"Usage:unregister devicename		unregister device from kernel\n");
+	return EXIT_FAILURE;
+}
+
+int attach_usage(void)
+{
+	fprintf(stderr, "Usage:attach cset_uuid|cachedevice datadevice\n");
+	return EXIT_FAILURE;
+}
+
+int detach_usage(void)
+{
+	fprintf(stderr, "Usage:detach devicename\n");
+	return EXIT_FAILURE;
+}
+
+int setcachemode_usage(void)
+{
+	fprintf(stderr, "Usage:set-cachemode devicename modetype\n");
+	return EXIT_FAILURE;
+}
+
+int setlabel_usage(void)
+{
+	fprintf(stderr,
+		"Usage:set-label devicename label\n(only for backend device)\n");
+	return EXIT_FAILURE;
+}
+
+void free_dev(struct list_head *head)
+{
+	struct dev *dev;
+
+	list_for_each_entry(dev, head, dev_list) {
+		free(dev);
+	}
+}
+
+int show_bdevs_detail(void)
+{
+	struct list_head head;
+	struct dev *devs;
+
+	INIT_LIST_HEAD(&head);
+	int ret;
 
-/*
- * Portions Copyright (c) 1996-2001, PostgreSQL Global Development Group (Any
- * use permitted, subject to terms of PostgreSQL license; see.)
-
- * If we have a 64-bit integer type, then a 64-bit CRC looks just like the
- * usual sort of implementation. (See Ross Williams' excellent introduction
- * A PAINLESS GUIDE TO CRC ERROR DETECTION ALGORITHMS, available from
- * ftp://ftp.rocksoft.com/papers/crc_v3.txt or several other net sites.)
- * If we have no working 64-bit type, then fake it with two 32-bit registers.
- *
- * The present implementation is a normal (not "reflected", in Williams'
- * terms) 64-bit CRC, using initial all-ones register contents and a final
- * bit inversion. The chosen polynomial is borrowed from the DLT1 spec
- * (ECMA-182, available from http://www.ecma.ch/ecma1/STAND/ECMA-182.HTM):
- *
- * x^64 + x^62 + x^57 + x^55 + x^54 + x^53 + x^52 + x^47 + x^46 + x^45 +
- * x^40 + x^39 + x^38 + x^37 + x^35 + x^33 + x^32 + x^31 + x^29 + x^27 +
- * x^24 + x^23 + x^22 + x^21 + x^19 + x^17 + x^13 + x^12 + x^10 + x^9 +
- * x^7 + x^4 + x + 1
-*/
-
-static const uint64_t crc_table[256] = {
-	0x0000000000000000ULL, 0x42F0E1EBA9EA3693ULL, 0x85E1C3D753D46D26ULL,
-	0xC711223CFA3E5BB5ULL, 0x493366450E42ECDFULL, 0x0BC387AEA7A8DA4CULL,
-	0xCCD2A5925D9681F9ULL, 0x8E224479F47CB76AULL, 0x9266CC8A1C85D9BEULL,
-	0xD0962D61B56FEF2DULL, 0x17870F5D4F51B498ULL, 0x5577EEB6E6BB820BULL,
-	0xDB55AACF12C73561ULL, 0x99A54B24BB2D03F2ULL, 0x5EB4691841135847ULL,
-	0x1C4488F3E8F96ED4ULL, 0x663D78FF90E185EFULL, 0x24CD9914390BB37CULL,
-	0xE3DCBB28C335E8C9ULL, 0xA12C5AC36ADFDE5AULL, 0x2F0E1EBA9EA36930ULL,
-	0x6DFEFF5137495FA3ULL, 0xAAEFDD6DCD770416ULL, 0xE81F3C86649D3285ULL,
-	0xF45BB4758C645C51ULL, 0xB6AB559E258E6AC2ULL, 0x71BA77A2DFB03177ULL,
-	0x334A9649765A07E4ULL, 0xBD68D2308226B08EULL, 0xFF9833DB2BCC861DULL,
-	0x388911E7D1F2DDA8ULL, 0x7A79F00C7818EB3BULL, 0xCC7AF1FF21C30BDEULL,
-	0x8E8A101488293D4DULL, 0x499B3228721766F8ULL, 0x0B6BD3C3DBFD506BULL,
-	0x854997BA2F81E701ULL, 0xC7B97651866BD192ULL, 0x00A8546D7C558A27ULL,
-	0x4258B586D5BFBCB4ULL, 0x5E1C3D753D46D260ULL, 0x1CECDC9E94ACE4F3ULL,
-	0xDBFDFEA26E92BF46ULL, 0x990D1F49C77889D5ULL, 0x172F5B3033043EBFULL,
-	0x55DFBADB9AEE082CULL, 0x92CE98E760D05399ULL, 0xD03E790CC93A650AULL,
-	0xAA478900B1228E31ULL, 0xE8B768EB18C8B8A2ULL, 0x2FA64AD7E2F6E317ULL,
-	0x6D56AB3C4B1CD584ULL, 0xE374EF45BF6062EEULL, 0xA1840EAE168A547DULL,
-	0x66952C92ECB40FC8ULL, 0x2465CD79455E395BULL, 0x3821458AADA7578FULL,
-	0x7AD1A461044D611CULL, 0xBDC0865DFE733AA9ULL, 0xFF3067B657990C3AULL,
-	0x711223CFA3E5BB50ULL, 0x33E2C2240A0F8DC3ULL, 0xF4F3E018F031D676ULL,
-	0xB60301F359DBE0E5ULL, 0xDA050215EA6C212FULL, 0x98F5E3FE438617BCULL,
-	0x5FE4C1C2B9B84C09ULL, 0x1D14202910527A9AULL, 0x93366450E42ECDF0ULL,
-	0xD1C685BB4DC4FB63ULL, 0x16D7A787B7FAA0D6ULL, 0x5427466C1E109645ULL,
-	0x4863CE9FF6E9F891ULL, 0x0A932F745F03CE02ULL, 0xCD820D48A53D95B7ULL,
-	0x8F72ECA30CD7A324ULL, 0x0150A8DAF8AB144EULL, 0x43A04931514122DDULL,
-	0x84B16B0DAB7F7968ULL, 0xC6418AE602954FFBULL, 0xBC387AEA7A8DA4C0ULL,
-	0xFEC89B01D3679253ULL, 0x39D9B93D2959C9E6ULL, 0x7B2958D680B3FF75ULL,
-	0xF50B1CAF74CF481FULL, 0xB7FBFD44DD257E8CULL, 0x70EADF78271B2539ULL,
-	0x321A3E938EF113AAULL, 0x2E5EB66066087D7EULL, 0x6CAE578BCFE24BEDULL,
-	0xABBF75B735DC1058ULL, 0xE94F945C9C3626CBULL, 0x676DD025684A91A1ULL,
-	0x259D31CEC1A0A732ULL, 0xE28C13F23B9EFC87ULL, 0xA07CF2199274CA14ULL,
-	0x167FF3EACBAF2AF1ULL, 0x548F120162451C62ULL, 0x939E303D987B47D7ULL,
-	0xD16ED1D631917144ULL, 0x5F4C95AFC5EDC62EULL, 0x1DBC74446C07F0BDULL,
-	0xDAAD56789639AB08ULL, 0x985DB7933FD39D9BULL, 0x84193F60D72AF34FULL,
-	0xC6E9DE8B7EC0C5DCULL, 0x01F8FCB784FE9E69ULL, 0x43081D5C2D14A8FAULL,
-	0xCD2A5925D9681F90ULL, 0x8FDAB8CE70822903ULL, 0x48CB9AF28ABC72B6ULL,
-	0x0A3B7B1923564425ULL, 0x70428B155B4EAF1EULL, 0x32B26AFEF2A4998DULL,
-	0xF5A348C2089AC238ULL, 0xB753A929A170F4ABULL, 0x3971ED50550C43C1ULL,
-	0x7B810CBBFCE67552ULL, 0xBC902E8706D82EE7ULL, 0xFE60CF6CAF321874ULL,
-	0xE224479F47CB76A0ULL, 0xA0D4A674EE214033ULL, 0x67C58448141F1B86ULL,
-	0x253565A3BDF52D15ULL, 0xAB1721DA49899A7FULL, 0xE9E7C031E063ACECULL,
-	0x2EF6E20D1A5DF759ULL, 0x6C0603E6B3B7C1CAULL, 0xF6FAE5C07D3274CDULL,
-	0xB40A042BD4D8425EULL, 0x731B26172EE619EBULL, 0x31EBC7FC870C2F78ULL,
-	0xBFC9838573709812ULL, 0xFD39626EDA9AAE81ULL, 0x3A28405220A4F534ULL,
-	0x78D8A1B9894EC3A7ULL, 0x649C294A61B7AD73ULL, 0x266CC8A1C85D9BE0ULL,
-	0xE17DEA9D3263C055ULL, 0xA38D0B769B89F6C6ULL, 0x2DAF4F0F6FF541ACULL,
-	0x6F5FAEE4C61F773FULL, 0xA84E8CD83C212C8AULL, 0xEABE6D3395CB1A19ULL,
-	0x90C79D3FEDD3F122ULL, 0xD2377CD44439C7B1ULL, 0x15265EE8BE079C04ULL,
-	0x57D6BF0317EDAA97ULL, 0xD9F4FB7AE3911DFDULL, 0x9B041A914A7B2B6EULL,
-	0x5C1538ADB04570DBULL, 0x1EE5D94619AF4648ULL, 0x02A151B5F156289CULL,
-	0x4051B05E58BC1E0FULL, 0x87409262A28245BAULL, 0xC5B073890B687329ULL,
-	0x4B9237F0FF14C443ULL, 0x0962D61B56FEF2D0ULL, 0xCE73F427ACC0A965ULL,
-	0x8C8315CC052A9FF6ULL, 0x3A80143F5CF17F13ULL, 0x7870F5D4F51B4980ULL,
-	0xBF61D7E80F251235ULL, 0xFD913603A6CF24A6ULL, 0x73B3727A52B393CCULL,
-	0x31439391FB59A55FULL, 0xF652B1AD0167FEEAULL, 0xB4A25046A88DC879ULL,
-	0xA8E6D8B54074A6ADULL, 0xEA16395EE99E903EULL, 0x2D071B6213A0CB8BULL,
-	0x6FF7FA89BA4AFD18ULL, 0xE1D5BEF04E364A72ULL, 0xA3255F1BE7DC7CE1ULL,
-	0x64347D271DE22754ULL, 0x26C49CCCB40811C7ULL, 0x5CBD6CC0CC10FAFCULL,
-	0x1E4D8D2B65FACC6FULL, 0xD95CAF179FC497DAULL, 0x9BAC4EFC362EA149ULL,
-	0x158E0A85C2521623ULL, 0x577EEB6E6BB820B0ULL, 0x906FC95291867B05ULL,
-	0xD29F28B9386C4D96ULL, 0xCEDBA04AD0952342ULL, 0x8C2B41A1797F15D1ULL,
-	0x4B3A639D83414E64ULL, 0x09CA82762AAB78F7ULL, 0x87E8C60FDED7CF9DULL,
-	0xC51827E4773DF90EULL, 0x020905D88D03A2BBULL, 0x40F9E43324E99428ULL,
-	0x2CFFE7D5975E55E2ULL, 0x6E0F063E3EB46371ULL, 0xA91E2402C48A38C4ULL,
-	0xEBEEC5E96D600E57ULL, 0x65CC8190991CB93DULL, 0x273C607B30F68FAEULL,
-	0xE02D4247CAC8D41BULL, 0xA2DDA3AC6322E288ULL, 0xBE992B5F8BDB8C5CULL,
-	0xFC69CAB42231BACFULL, 0x3B78E888D80FE17AULL, 0x7988096371E5D7E9ULL,
-	0xF7AA4D1A85996083ULL, 0xB55AACF12C735610ULL, 0x724B8ECDD64D0DA5ULL,
-	0x30BB6F267FA73B36ULL, 0x4AC29F2A07BFD00DULL, 0x08327EC1AE55E69EULL,
-	0xCF235CFD546BBD2BULL, 0x8DD3BD16FD818BB8ULL, 0x03F1F96F09FD3CD2ULL,
-	0x41011884A0170A41ULL, 0x86103AB85A2951F4ULL, 0xC4E0DB53F3C36767ULL,
-	0xD8A453A01B3A09B3ULL, 0x9A54B24BB2D03F20ULL, 0x5D45907748EE6495ULL,
-	0x1FB5719CE1045206ULL, 0x919735E51578E56CULL, 0xD367D40EBC92D3FFULL,
-	0x1476F63246AC884AULL, 0x568617D9EF46BED9ULL, 0xE085162AB69D5E3CULL,
-	0xA275F7C11F7768AFULL, 0x6564D5FDE549331AULL, 0x279434164CA30589ULL,
-	0xA9B6706FB8DFB2E3ULL, 0xEB46918411358470ULL, 0x2C57B3B8EB0BDFC5ULL,
-	0x6EA7525342E1E956ULL, 0x72E3DAA0AA188782ULL, 0x30133B4B03F2B111ULL,
-	0xF7021977F9CCEAA4ULL, 0xB5F2F89C5026DC37ULL, 0x3BD0BCE5A45A6B5DULL,
-	0x79205D0E0DB05DCEULL, 0xBE317F32F78E067BULL, 0xFCC19ED95E6430E8ULL,
-	0x86B86ED5267CDBD3ULL, 0xC4488F3E8F96ED40ULL, 0x0359AD0275A8B6F5ULL,
-	0x41A94CE9DC428066ULL, 0xCF8B0890283E370CULL, 0x8D7BE97B81D4019FULL,
-	0x4A6ACB477BEA5A2AULL, 0x089A2AACD2006CB9ULL, 0x14DEA25F3AF9026DULL,
-	0x562E43B4931334FEULL, 0x913F6188692D6F4BULL, 0xD3CF8063C0C759D8ULL,
-	0x5DEDC41A34BBEEB2ULL, 0x1F1D25F19D51D821ULL, 0xD80C07CD676F8394ULL,
-	0x9AFCE626CE85B507ULL
-};
-
-uint64_t crc64(const void *_data, size_t len)
-{
-	uint64_t crc = 0xFFFFFFFFFFFFFFFFULL;
-	const unsigned char *data = _data;
-
-	while (len--) {
-		int i = ((int) (crc >> 56) ^ *data++) & 0xFF;
-		crc = crc_table[i] ^ (crc << 8);
-	}
-
-	return crc ^ 0xFFFFFFFFFFFFFFFFULL;
+	ret = list_bdevs(&head);
+	if (ret != 0) {
+		fprintf(stderr, "Failed to list devices\n");
+		return ret;
+	}
+	printf("Name\t\tUuid\t\t\t\t\tCset_Uuid\t\t\t\tType\t\tState");
+	printf("\t\t\tBname\t\tAttachToDev\tAttachToCset\n");
+	list_for_each_entry(devs, &head, dev_list) {
+		printf("%s\t%s\t%s\t%lu", devs->name, devs->uuid,
+		       devs->cset, devs->version);
+		switch (devs->version) {
+			// These are handled the same by the kernel
+		case BCACHE_SB_VERSION_CDEV:
+		case BCACHE_SB_VERSION_CDEV_WITH_UUID:
+			printf(" (cache)");
+			break;
+			// The second adds data offset supporet
+		case BCACHE_SB_VERSION_BDEV:
+		case BCACHE_SB_VERSION_BDEV_WITH_OFFSET:
+			printf(" (data)");
+			break;
+		default:
+			printf(" (unknown)");
+			break;
+		}
+		printf("\t%-16s", devs->state);
+		printf("\t%-16s", devs->bname);
+		char attachdev[30];
+
+		if (strlen(devs->attachuuid) == 36) {
+			cset_to_devname(&head, devs->cset, attachdev);
+		} else if (devs->version == BCACHE_SB_VERSION_CDEV
+			   || devs->version ==
+			   BCACHE_SB_VERSION_CDEV_WITH_UUID) {
+			strcpy(attachdev, BCACHE_NO_SUPPORT);
+		} else {
+			strcpy(attachdev, BCACHE_ATTACH_ALONE);
+		}
+		printf("%-16s", attachdev);
+		printf("%s", devs->attachuuid);
+		putchar('\n');
+	}
+	free_dev(&head);
+	return 0;
+}
+
+
+int show_bdevs(void)
+{
+	struct list_head head;
+	struct dev *devs;
+
+	INIT_LIST_HEAD(&head);
+	int ret;
+
+	ret = list_bdevs(&head);
+	if (ret != 0) {
+		fprintf(stderr, "Failed to list devices\n");
+		return ret;
+	}
+
+	printf("Name\t\tType\t\tState\t\t\tBname\t\tAttachToDev\n");
+	list_for_each_entry(devs, &head, dev_list) {
+		printf("%s\t%lu", devs->name, devs->version);
+		switch (devs->version) {
+			// These are handled the same by the kernel
+		case BCACHE_SB_VERSION_CDEV:
+		case BCACHE_SB_VERSION_CDEV_WITH_UUID:
+			printf(" (cache)");
+			break;
+
+			// The second adds data offset supporet
+		case BCACHE_SB_VERSION_BDEV:
+		case BCACHE_SB_VERSION_BDEV_WITH_OFFSET:
+			printf(" (data)");
+			break;
+
+		default:
+			printf(" (unknown)");
+			break;
+		}
+
+		printf("\t%-16s", devs->state);
+		printf("\t%-16s", devs->bname);
+
+		char attachdev[30];
+
+		if (strlen(devs->attachuuid) == 36) {
+			cset_to_devname(&head, devs->cset, attachdev);
+		} else if (devs->version == BCACHE_SB_VERSION_CDEV
+			   || devs->version ==
+			   BCACHE_SB_VERSION_CDEV_WITH_UUID) {
+			strcpy(attachdev, BCACHE_NO_SUPPORT);
+		} else {
+			strcpy(attachdev, BCACHE_ATTACH_ALONE);
+		}
+		printf("%s", attachdev);
+		putchar('\n');
+	}
+	free_dev(&head);
+	return 0;
+}
+
+int detail_single(char *devname)
+{
+	struct bdev bd;
+	struct cdev cd;
+	int type = 1;
+	int ret;
+
+	ret = detail_dev(devname, &bd, &cd, &type);
+	if (ret != 0) {
+		fprintf(stderr, "Failed to detail device\n");
+		return ret;
+	}
+	if (type == BCACHE_SB_VERSION_BDEV) {
+		printf("sb.magic\t\t%s\n", bd.base.magic);
+		printf("sb.first_sector\t\t%" PRIu64 "\n",
+		       bd.base.first_sector);
+		printf("sb.csum\t\t\t%" PRIX64 "\n", bd.base.csum);
+		printf("sb.version\t\t%" PRIu64, bd.base.version);
+		printf(" [backing device]\n");
+		putchar('\n');
+		printf("dev.label\t\t");
+		if (*bd.base.label)
+			print_encode(bd.base.label);
+		else
+			printf("(empty)");
+		putchar('\n');
+		printf("dev.uuid\t\t%s\n", bd.base.uuid);
+		printf("dev.sectors_per_block\t%u\n"
+		       "dev.sectors_per_bucket\t%u\n",
+		       bd.base.sectors_per_block,
+		       bd.base.sectors_per_bucket);
+		printf("dev.data.first_sector\t%u\n"
+		       "dev.data.cache_mode\t%d",
+		       bd.first_sector, bd.cache_mode);
+		switch (bd.cache_mode) {
+		case CACHE_MODE_WRITETHROUGH:
+			printf(" [writethrough]\n");
+			break;
+		case CACHE_MODE_WRITEBACK:
+			printf(" [writeback]\n");
+			break;
+		case CACHE_MODE_WRITEAROUND:
+			printf(" [writearound]\n");
+			break;
+		case CACHE_MODE_NONE:
+			printf(" [no caching]\n");
+			break;
+		default:
+			putchar('\n');
+		}
+		printf("dev.data.cache_state\t%u", bd.cache_state);
+		switch (bd.cache_state) {
+		case BDEV_STATE_NONE:
+			printf(" [detached]\n");
+			break;
+		case BDEV_STATE_CLEAN:
+			printf(" [clean]\n");
+			break;
+		case BDEV_STATE_DIRTY:
+			printf(" [dirty]\n");
+			break;
+		case BDEV_STATE_STALE:
+			printf(" [inconsistent]\n");
+			break;
+		default:
+			putchar('\n');
+		}
+
+		putchar('\n');
+		printf("cset.uuid\t\t%s\n", bd.base.cset);
+	} else if (type == BCACHE_SB_VERSION_CDEV
+		   || type == BCACHE_SB_VERSION_CDEV_WITH_UUID) {
+		printf("sb.magic\t\t%s\n", cd.base.magic);
+		printf("sb.first_sector\t\t%" PRIu64 "\n",
+		       cd.base.first_sector);
+		printf("sb.csum\t\t\t%" PRIX64 "\n", cd.base.csum);
+		printf("sb.version\t\t%" PRIu64, cd.base.version);
+		printf(" [cache device]\n");
+		putchar('\n');
+		printf("dev.label\t\t");
+		if (*cd.base.label)
+			print_encode(cd.base.label);
+		else
+			printf("(empty)");
+		putchar('\n');
+		printf("dev.uuid\t\t%s\n", cd.base.uuid);
+		printf("dev.sectors_per_block\t%u\n"
+		       "dev.sectors_per_bucket\t%u\n",
+		       cd.base.sectors_per_block,
+		       cd.base.sectors_per_bucket);
+		printf("dev.cache.first_sector\t%u\n"
+		       "dev.cache.cache_sectors\t%ju\n"
+		       "dev.cache.total_sectors\t%ju\n"
+		       "dev.cache.ordered\t%s\n"
+		       "dev.cache.discard\t%s\n"
+		       "dev.cache.pos\t\t%u\n"
+		       "dev.cache.replacement\t%d",
+		       cd.first_sector,
+		       cd.cache_sectors,
+		       cd.total_sectors,
+		       cd.ordered ? "yes" : "no",
+		       cd.discard ? "yes" : "no", cd.pos, cd.replacement);
+		switch (cd.replacement) {
+		case CACHE_REPLACEMENT_LRU:
+			printf(" [lru]\n");
+			break;
+		case CACHE_REPLACEMENT_FIFO:
+			printf(" [fifo]\n");
+			break;
+		case CACHE_REPLACEMENT_RANDOM:
+			printf(" [random]\n");
+			break;
+		default:
+			putchar('\n');
+		}
+
+		putchar('\n');
+		printf("cset.uuid\t\t%s\n", cd.base.cset);
+	} else {
+		return 1;
+	}
+	return 0;
+}
+
+int tree(void)
+{
+	struct list_head head;
+	struct dev *devs, *tmp;
+
+	INIT_LIST_HEAD(&head);
+	int ret;
+
+	ret = list_bdevs(&head);
+	if (ret != 0) {
+		fprintf(stderr, "Failed to list devices\n");
+		return ret;
+	}
+	struct libscols_table *tb;
+	struct libscols_line *dad, *son;
+	enum { COL_CSET, COL_BNAME };
+	setlocale(LC_ALL, "");
+	tb = scols_new_table();
+	scols_table_new_column(tb, ".", 0.1, SCOLS_FL_TREE);
+	scols_table_new_column(tb, "", 2, SCOLS_FL_TRUNC);
+	list_for_each_entry(devs, &head, dev_list) {
+		if ((devs->version == BCACHE_SB_VERSION_CDEV
+		     || devs->version == BCACHE_SB_VERSION_CDEV_WITH_UUID)
+		    && strcmp(devs->state, BCACHE_BASIC_STATE_ACTIVE) == 0) {
+			dad = scols_table_new_line(tb, NULL);
+			scols_line_set_data(dad, COL_CSET, devs->name);
+			list_for_each_entry(tmp, &head, dev_list) {
+				if (strcmp(devs->cset, tmp->attachuuid) ==
+				    0) {
+					son =
+					    scols_table_new_line(tb, dad);
+					scols_line_set_data(son, COL_CSET,
+							    tmp->name);
+					scols_line_set_data(son, COL_BNAME,
+							    tmp->bname);
+				}
+			}
+		}
+	}
+	scols_print_table(tb);
+	scols_unref_table(tb);
+	free_dev(&head);
+	return 0;
+}
+
+int attach_both(char *cdev, char *backdev)
+{
+	struct bdev bd;
+	struct cdev cd;
+	int type = 1;
+	int ret;
+	char buf[100];
+
+	ret = detail_dev(backdev, &bd, &cd, &type);
+	if (ret != 0)
+		return ret;
+	if (type != BCACHE_SB_VERSION_BDEV
+	    && type != BCACHE_SB_VERSION_BDEV_WITH_OFFSET) {
+		fprintf(stderr, "%s is not an backend device\n", backdev);
+		return 1;
+	}
+	if (strcmp(bd.base.attachuuid, BCACHE_BNAME_NOT_EXIST) != 0) {
+		fprintf(stderr,
+			"This device have attached to another cset\n");
+		return 1;
+	}
+
+	if (strlen(cdev) != 36) {
+		ret = detail_dev(cdev, &bd, &cd, &type);
+		if (type != BCACHE_SB_VERSION_CDEV
+		    && type != BCACHE_SB_VERSION_CDEV_WITH_UUID) {
+			fprintf(stderr, "%s is not an cache device\n", cdev);
+			return 1;
+		}
+		strcpy(buf, cd.base.cset);
+	} else {
+		strcpy(buf, cdev);
+	}
+	return attach_backdev(buf, backdev);
+}
+
+bool has_permission(void)
+{
+	uid_t euid = geteuid();
+
+	if (euid != 0)
+		return false;
+	return true;
+}
+
+int main(int argc, char **argv)
+{
+	char *subcmd;
+
+	if (!has_permission()) {
+		fprintf(stderr,
+		"Only root or users who has root priviledges can run this command\n");
+		return 1;
+	}
+	if (argc < 2) {
+		main_usage();
+		return 1;
+	}
+	subcmd = argv[1];
+	argc--;
+	argv += 1;
+	char *devname = NULL;
+	if (strcmp(subcmd, "make") == 0)
+		return make_bcache(argc, argv);
+	else if (strcmp(subcmd, "show") == 0) {
+		int o = 0;
+		int more = 0;
+		int device = 0;
+		int help = 0;
+
+		static struct option long_options[] = {
+			{"more", no_argument, 0, 'm'},
+			{"help", no_argument, 0, 'h'},
+			{"device", required_argument, 0, 'd'},
+			{0, 0, 0, 0}
+		};
+		int option_index = 0;
+
+		while ((o =
+			getopt_long(argc, argv, "hmd:", long_options,
+				    &option_index)) != EOF) {
+			switch (o) {
+			case 'd':
+				devname = optarg;
+				device = 1;
+				break;
+			case 'm':
+				more = 1;
+				break;
+			case 'h':
+				help = 1;
+				break;
+			case '?':
+				return 1;
+			}
+		}
+		argc -= optind;
+		if (help || argc != 0) {
+			return show_usage();
+		} else if (more) {
+			return show_bdevs_detail();
+		} else if (device) {
+			if (bad_dev(&devname)) {
+				fprintf(stderr,
+					"Error:Wrong device name found\n");
+				return 1;
+			}
+			return detail_single(devname);
+		} else {
+			return show_bdevs();
+		}
+	} else if (strcmp(subcmd, "tree") == 0) {
+		if (argc != 1)
+			return tree_usage();
+		return tree();
+	} else if (strcmp(subcmd, "register") == 0) {
+		if (argc != 2 || strcmp(argv[1], "-h") == 0)
+			return register_usage();
+		devname = argv[1];
+		if (bad_dev(&devname)) {
+			fprintf(stderr, "Error:Wrong device name found\n");
+			return 1;
+		}
+		return register_dev(devname);
+	} else if (strcmp(subcmd, "unregister") == 0) {
+		if (argc != 2 || strcmp(argv[1], "-h") == 0)
+			return unregister_usage();
+		devname = argv[1];
+		if (bad_dev(&devname)) {
+			fprintf(stderr, "Error:Wrong device name found\n");
+			return 1;
+		}
+		struct bdev bd;
+		struct cdev cd;
+		int type = 1;
+		int ret;
+
+		ret = detail_dev(devname, &bd, &cd, &type);
+		if (ret != 0)
+			return ret;
+		if (type == BCACHE_SB_VERSION_BDEV) {
+			return stop_backdev(devname);
+		} else if (type == BCACHE_SB_VERSION_CDEV
+			   || type == BCACHE_SB_VERSION_CDEV_WITH_UUID) {
+			return unregister_cset(cd.base.cset);
+		}
+		return 1;
+	} else if (strcmp(subcmd, "attach") == 0) {
+		if (argc != 3 || strcmp(argv[1], "-h") == 0)
+			return attach_usage();
+		devname = argv[2];
+		char *attachto = argv[1];
+
+		if ((bad_uuid(attachto) && bad_dev(&attachto))
+			|| bad_dev(&devname)) {
+			fprintf(stderr,
+			"Error:Wrong device name or cache_set uuid found\n");
+			return 1;
+		}
+		return attach_both(attachto, devname);
+	} else if (strcmp(subcmd, "detach") == 0) {
+		if (argc != 2 || strcmp(argv[1], "-h") == 0)
+			return detach_usage();
+		devname = argv[1];
+		if (bad_dev(&devname)) {
+			fprintf(stderr, "Error:Wrong device name found\n");
+			return 1;
+		}
+		return detach_backdev(devname);
+	} else if (strcmp(subcmd, "set-cachemode") == 0) {
+		if (argc != 3)
+			return setcachemode_usage();
+		devname = argv[1];
+		if (bad_dev(&devname)) {
+			fprintf(stderr, "Error:Wrong device name found\n");
+			return 1;
+		}
+		struct bdev bd;
+		struct cdev cd;
+		int type = 1;
+		int ret;
+
+		ret = detail_dev(devname, &bd, &cd, &type);
+		if (ret != 0) {
+			fprintf(stderr,
+			"This device doesn't exist or failed to receive info from this device\n");
+			return ret;
+		}
+		if (type != BCACHE_SB_VERSION_BDEV
+		    && type != BCACHE_SB_VERSION_BDEV_WITH_OFFSET) {
+			fprintf(stderr,
+				"Only backend device is suppported\n");
+			return 1;
+		}
+		return set_backdev_cachemode(devname, argv[2]);
+	} else if (strcmp(subcmd, "set-label") == 0) {
+		if (argc != 3)
+			return setlabel_usage();
+		devname = argv[1];
+		if (bad_dev(&devname)) {
+			fprintf(stderr, "Error:Wrong device name found\n");
+			return 1;
+		}
+		struct bdev bd;
+		struct cdev cd;
+		int type = 5;
+		int ret;
+
+		ret = detail_dev(devname, &bd, &cd, &type);
+		if (ret != 0) {
+			fprintf(stderr,
+		"This device doesn't exist or failed to receive info from this device\n");
+			return ret;
+		}
+		if (type != BCACHE_SB_VERSION_BDEV
+		    && type != BCACHE_SB_VERSION_BDEV_WITH_OFFSET) {
+			fprintf(stderr,
+				"Only backend device is suppported\n");
+			return 1;
+		}
+		if (strlen(argv[2]) >= SB_LABEL_SIZE) {
+			fprintf(stderr, "Label is too long\n");
+			return 1;
+		}
+		return set_label(devname, argv[2]);
+	}
+	main_usage();
+	return 0;
 }
-- 
2.25.0

